## golang-github-evanw-esbuild 0.7.19

=== Makefile ===
ESBUILD_VERSION = $(shell cat version.txt)

esbuild: cmd/esbuild/*.go pkg/*/*.go internal/*/*.go go.mod
	go build "-ldflags=-s -w" ./cmd/esbuild

npm/esbuild-wasm/esbuild.wasm: cmd/esbuild/*.go pkg/*/*.go internal/*/*.go
	GOOS=js GOARCH=wasm go build -o npm/esbuild-wasm/esbuild.wasm ./cmd/esbuild

npm/esbuild-wasm/wasm_exec.js:
	cp "$(shell go env GOROOT)/misc/wasm/wasm_exec.js" npm/esbuild-wasm/wasm_exec.js

# These tests are for development
test:
	make -j5 test-go vet-go verify-source-map end-to-end-tests js-api-tests

# These tests are for release ("test-wasm" is not included in "test" because it's pretty slow)
test-all:
	make -j6 test-go vet-go verify-source-map end-to-end-tests js-api-tests test-wasm

# This includes tests of some 3rd-party libraries, which can be very slow
test-extra: test-all test-preact-splitting test-sucrase bench-rome-esbuild test-esprima test-rollup

test-go:
	go test ./internal/...

vet-go:
	go vet ./cmd/... ./internal/... ./pkg/...

fmt-go:
	go fmt ./cmd/... ./internal/... ./pkg/...

test-wasm:
	PATH="$(shell go env GOROOT)/misc/wasm:$$PATH" GOOS=js GOARCH=wasm go test ./internal/...

verify-source-map: cmd/esbuild/version.go | scripts/node_modules
	cd npm/esbuild && npm version "$(ESBUILD_VERSION)" --allow-same-version
	node scripts/verify-source-map.js

end-to-end-tests: cmd/esbuild/version.go | scripts/node_modules
	cd npm/esbuild && npm version "$(ESBUILD_VERSION)" --allow-same-version
	node scripts/end-to-end-tests.js

js-api-tests: cmd/esbuild/version.go | scripts/node_modules
	cd npm/esbuild && npm version "$(ESBUILD_VERSION)" --allow-same-version
	node scripts/js-api-tests.js

cmd/esbuild/version.go: version.txt
	node -e 'console.log(`package main\n\nconst esbuildVersion = "$(ESBUILD_VERSION)"`)' > cmd/esbuild/version.go

platform-all: cmd/esbuild/version.go test-all
	make -j11 \
		platform-windows \
		platform-windows-32 \
		platform-darwin \
		platform-freebsd \
		platform-freebsd-arm64 \
		platform-linux \
		platform-linux-32 \
		platform-linux-arm64 \
		platform-linux-ppc64le \
		platform-wasm \
		platform-neutral

platform-windows:
	cd npm/esbuild-windows-64 && npm version "$(ESBUILD_VERSION)" --allow-same-version
	GOOS=windows GOARCH=amd64 go build "-ldflags=-s -w" -o npm/esbuild-windows-64/esbuild.exe ./cmd/esbuild

platform-windows-32:
	cd npm/esbuild-windows-32 && npm version "$(ESBUILD_VERSION)" --allow-same-version
	GOOS=windows GOARCH=386 go build "-ldflags=-s -w" -o npm/esbuild-windows-32/esbuild.exe ./cmd/esbuild

platform-unixlike:
	test -n "$(GOOS)" && test -n "$(GOARCH)" && test -n "$(NPMDIR)"
	mkdir -p "$(NPMDIR)/bin"
	cd "$(NPMDIR)" && npm version "$(ESBUILD_VERSION)" --allow-same-version
	GOOS="$(GOOS)" GOARCH="$(GOARCH)" go build "-ldflags=-s -w" -o "$(NPMDIR)/bin/esbuild" ./cmd/esbuild

platform-darwin:
	make GOOS=darwin GOARCH=amd64 NPMDIR=npm/esbuild-darwin-64 platform-unixlike

platform-freebsd:
	make GOOS=freebsd GOARCH=amd64 NPMDIR=npm/esbuild-freebsd-64 platform-unixlike

platform-freebsd-arm64:
	make GOOS=freebsd GOARCH=arm64 NPMDIR=npm/esbuild-freebsd-arm64 platform-unixlike

platform-linux:
	make GOOS=linux GOARCH=amd64 NPMDIR=npm/esbuild-linux-64 platform-unixlike

platform-linux-32:
	make GOOS=linux GOARCH=386 NPMDIR=npm/esbuild-linux-32 platform-unixlike

platform-linux-arm64:
	make GOOS=linux GOARCH=arm64 NPMDIR=npm/esbuild-linux-arm64 platform-unixlike

platform-linux-ppc64le:
	make GOOS=linux GOARCH=ppc64le NPMDIR=npm/esbuild-linux-ppc64le platform-unixlike

platform-wasm: esbuild npm/esbuild-wasm/esbuild.wasm | scripts/node_modules npm/esbuild-wasm/wasm_exec.js
	cd npm/esbuild-wasm && npm version "$(ESBUILD_VERSION)" --allow-same-version
	mkdir -p npm/esbuild-wasm/lib
	node scripts/esbuild.js ./esbuild --wasm

platform-neutral: esbuild | scripts/node_modules
	cd npm/esbuild && npm version "$(ESBUILD_VERSION)" --allow-same-version
	node scripts/esbuild.js ./esbuild

test-otp:
	test -n "$(OTP)" && echo publish --otp="$(OTP)"

publish-all: cmd/esbuild/version.go test-all test-extra
	@test master = "`git branch --show-current`" || (echo "Refusing to publish from non-master branch `git branch --show-current`" && false)
	@echo "Checking for unpushed commits..." && git fetch
	@test "" = "`git cherry`" || (echo "Refusing to publish with unpushed commits" && false)
	rm -fr npm && git checkout npm
	@echo Enter one-time password:
	@read OTP && OTP="$$OTP" make -j5 \
		publish-windows \
		publish-windows-32 \
		publish-darwin \
		publish-freebsd \
		publish-freebsd-arm64
	@echo Enter one-time password:
	@read OTP && OTP="$$OTP" make -j5 \
		publish-linux \
		publish-linux-32 \
		publish-linux-arm64 \
		publish-linux-ppc64le \
		publish-wasm
	make publish-neutral # Do this after to avoid race conditions
	git commit -am "publish $(ESBUILD_VERSION) to npm"
	git tag "v$(ESBUILD_VERSION)"
	git push origin master "v$(ESBUILD_VERSION)"

publish-windows: platform-windows
	test -n "$(OTP)" && cd npm/esbuild-windows-64 && npm publish --otp="$(OTP)"

publish-windows-32: platform-windows-32
	test -n "$(OTP)" && cd npm/esbuild-windows-32 && npm publish --otp="$(OTP)"

publish-darwin: platform-darwin
	test -n "$(OTP)" && cd npm/esbuild-darwin-64 && npm publish --otp="$(OTP)"

publish-freebsd: platform-freebsd
	test -n "$(OTP)" && cd npm/esbuild-freebsd-64 && npm publish --otp="$(OTP)"

publish-freebsd-arm64: platform-freebsd-arm64
	test -n "$(OTP)" && cd npm/esbuild-freebsd-arm64 && npm publish --otp="$(OTP)"

publish-linux: platform-linux
	test -n "$(OTP)" && cd npm/esbuild-linux-64 && npm publish --otp="$(OTP)"

publish-linux-32: platform-linux-32
	test -n "$(OTP)" && cd npm/esbuild-linux-32 && npm publish --otp="$(OTP)"

publish-linux-arm64: platform-linux-arm64
	test -n "$(OTP)" && cd npm/esbuild-linux-arm64 && npm publish --otp="$(OTP)"

publish-linux-ppc64le: platform-linux-ppc64le
	test -n "$(OTP)" && cd npm/esbuild-linux-ppc64le && npm publish --otp="$(OTP)"

publish-wasm: platform-wasm
	test -n "$(OTP)" && cd npm/esbuild-wasm && npm publish --otp="$(OTP)"

publish-neutral: platform-neutral
	cd npm/esbuild && npm publish

clean:
	rm -f esbuild
	rm -f npm/esbuild-windows-32/esbuild.exe
	rm -f npm/esbuild-windows-64/esbuild.exe
	rm -rf npm/esbuild-darwin-64/bin
	rm -rf npm/esbuild-freebsd-64/bin
	rm -rf npm/esbuild-freebsd-amd64/bin
	rm -rf npm/esbuild-linux-32/bin
	rm -rf npm/esbuild-linux-64/bin
	rm -rf npm/esbuild-linux-arm64/bin
	rm -rf npm/esbuild-linux-ppc64le/bin
	rm -f npm/esbuild-wasm/esbuild.wasm npm/esbuild-wasm/wasm_exec.js
	rm -rf npm/esbuild/lib
	rm -rf npm/esbuild-wasm/lib
	go clean -testcache ./internal/...

# This also cleans directories containing cached code from other projects
clean-all: clean
	rm -fr github demo bench

################################################################################
# These npm packages are used for benchmarks. Instal them in subdirectories
# because we want to install the same package name at multiple versions

require/webpack/node_modules:
	mkdir -p require/webpack
	echo '{}' > require/webpack/package.json
	cd require/webpack && npm install webpack@4.44.2 webpack-cli@3.3.12 ts-loader@8.0.4 typescript@4.0.3

require/webpack5/node_modules:
	mkdir -p require/webpack5
	echo '{}' > require/webpack5/package.json
	cd require/webpack5 && npm install webpack@5.0.0-rc.4 webpack-cli@4.0.0-rc.1 ts-loader@8.0.4 typescript@4.0.3

require/rollup/node_modules:
	mkdir -p require/rollup
	echo '{}' > require/rollup/package.json
	cd require/rollup && npm install rollup@2.29.0 rollup-plugin-terser@7.0.2

require/parcel/node_modules:
	mkdir -p require/parcel
	echo '{}' > require/parcel/package.json
	cd require/parcel && npm install parcel@1.12.4

	# Fix a bug where parcel doesn't know about one specific node builtin module
	mkdir -p require/parcel/node_modules/inspector
	touch require/parcel/node_modules/inspector/index.js

require/fusebox/node_modules:
	mkdir -p require/fusebox
	echo '{}' > require/fusebox/package.json
	cd require/fusebox && npm install fuse-box@4.0.0-next.444

require/parcel2/node_modules:
	mkdir -p require/parcel2
	echo '{}' > require/parcel2/package.json
	cd require/parcel2 && npm install parcel@2.0.0-nightly.420 @parcel/transformer-typescript-tsc@2.0.0-beta.1 typescript@3.9.5

scripts/node_modules:
	cd scripts && npm ci

################################################################################
# This downloads the kangax compat-table and generates browser support mappings

github/compat-table:
	mkdir -p github/compat-table
	git clone --depth 1 https://github.com/kangax/compat-table.git github/compat-table

compat-table: | github/compat-table
	node scripts/compat-table.js

################################################################################
# This runs the test262 official JavaScript test suite through esbuild

github/test262:
	mkdir -p github
	git clone --depth 1 https://github.com/tc39/test262.git github/test262

demo/test262: | github/test262
	mkdir -p demo/test262
	cp -r github/test262/test demo/test262/test

test262: esbuild | demo/test262
	node scripts/test262.js

################################################################################
# This runs UglifyJS's test suite through esbuild

github/uglify:
	mkdir -p github/uglify
	cd github/uglify && git init && git remote add origin https://github.com/mishoo/uglifyjs.git
	cd github/uglify && git fetch --depth 1 origin 83a3cbf1514e81292b749655f2f712e82a5a2ba8 && git checkout FETCH_HEAD

demo/uglify: | github/uglify
	mkdir -p demo
	cp -r github/uglify/ demo/uglify
	cd demo/uglify && npm i

uglify: esbuild | demo/uglify
	node scripts/uglify-tests.js

################################################################################
# This builds Rollup using esbuild and then uses it to run Rollup's test suite

TEST_ROLLUP_FIND = "compilerOptions": {

TEST_ROLLUP_REPLACE += "compilerOptions": {
TEST_ROLLUP_REPLACE += "baseUrl": ".",
TEST_ROLLUP_REPLACE += "paths": { "package.json": [".\/package.json"] },

TEST_ROLLUP_FLAGS += --bundle
TEST_ROLLUP_FLAGS += --external:fsevents
TEST_ROLLUP_FLAGS += --outfile=dist/rollup.js
TEST_ROLLUP_FLAGS += --platform=node
TEST_ROLLUP_FLAGS += --target=es6
TEST_ROLLUP_FLAGS += src/node-entry.ts

github/rollup:
	mkdir -p github
	git clone --depth 1 --branch v2.15.0 https://github.com/rollup/rollup.git github/rollup

demo/rollup: | github/rollup
	mkdir -p demo
	cp -RP github/rollup/ demo/rollup
	cd demo/rollup && npm ci

	# Patch over Rollup's custom "package.json" alias using "tsconfig.json"
	cat demo/rollup/tsconfig.json | sed 's/$(TEST_ROLLUP_FIND)/$(TEST_ROLLUP_REPLACE)/' > demo/rollup/tsconfig2.json
	mv demo/rollup/tsconfig2.json demo/rollup/tsconfig.json

test-rollup: esbuild | demo/rollup
	cd demo/rollup && ../../esbuild $(TEST_ROLLUP_FLAGS) && npm run test:only
	cd demo/rollup && ../../esbuild $(TEST_ROLLUP_FLAGS) --minify && npm run test:only

################################################################################
# This builds Sucrase using esbuild and then uses it to run Sucrase's test suite

PREACT_SPLITTING += import { h } from 'preact';
PREACT_SPLITTING += import { USE as use } from 'preact/hooks';
PREACT_SPLITTING += import { renderToString } from 'preact-render-to-string';
PREACT_SPLITTING += let Component = () => (use(() => {}), h('div'));
PREACT_SPLITTING += if (renderToString(h(Component)) !== '<div></div>') throw 'fail';

PREACT_HOOKS += useCallback
PREACT_HOOKS += useContext
PREACT_HOOKS += useDebugValue
PREACT_HOOKS += useEffect
PREACT_HOOKS += useErrorBoundary
PREACT_HOOKS += useImperativeHandle
PREACT_HOOKS += useLayoutEffect
PREACT_HOOKS += useMemo
PREACT_HOOKS += useReducer
PREACT_HOOKS += useRef
PREACT_HOOKS += useState

demo/preact-splitting:
	mkdir -p demo/preact-splitting/src
	cd demo/preact-splitting && echo '{}' > package.json && npm i preact@10.4.6 preact-render-to-string@5.1.10
	cd demo/preact-splitting && for h in $(PREACT_HOOKS); do echo "$(PREACT_SPLITTING)" | sed s/USE/$$h/ > src/$$h.js; done

=== debian/changelog ===
golang-github-evanw-esbuild (0.7.19-1) unstable; urgency=medium

  * Initial release (Closes: #972851)

 -- Anthony Fok <foka@debian.org>  Sun, 25 Oct 2020 02:14:32 -0600

=== debian/control ===
Source: golang-github-evanw-esbuild
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Anthony Fok <foka@debian.org>
Section: devel
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any,
               golang-github-kylelemons-godebug-dev (>= 1.1.0),
               golang-golang-x-sys-dev (>= 0.0~git20200501.bc7a7d4)
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-evanw-esbuild
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-evanw-esbuild.git
Homepage: https://github.com/evanw/esbuild
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/evanw/esbuild

Package: golang-github-evanw-esbuild-dev
Architecture: all
Depends: golang-github-kylelemons-godebug-dev (>= 1.1.0),
         golang-golang-x-sys-dev (>= 0.0~git20200501.bc7a7d4),
         ${misc:Depends}
Description: extremely fast JavaScript bundler and minifier (library)
 esbuild is a JavaScript bundler and minifier.  It packages up
 JavaScript and TypeScript code for distribution on the web.
 .
 Why build another JavaScript build tool?  The current build tools for the web
 are at least an order of magnitude slower than they should be.  It is hoped
 that this project serves as an "existence proof" that JavaScript tooling
 can be much, much faster.
 .
 This package contains the github.com/evanw/esbuild Go library.

Package: esbuild
Architecture: any
Section: javascript
Depends: ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: extremely fast JavaScript bundler and minifier (program)
 esbuild is a JavaScript bundler and minifier.  It packages up
 JavaScript and TypeScript code for distribution on the web.
 .
 Why build another JavaScript build tool?  The current build tools for the web
 are at least an order of magnitude slower than they should be.  It is hoped
 that this project serves as an "existence proof" that JavaScript tooling
 can be much, much faster.
 .
 This package contains the esbuild binary.

## golang-github-evanw-esbuild 0.8.2

=== Makefile ===
--- 
+++ 
@@ -11,11 +11,11 @@
 
 # These tests are for development
 test:
-	make -j5 test-go vet-go verify-source-map end-to-end-tests js-api-tests
+	make -j6 test-go vet-go verify-source-map end-to-end-tests js-api-tests plugin-tests ts-type-tests
 
 # These tests are for release ("test-wasm" is not included in "test" because it's pretty slow)
 test-all:
-	make -j6 test-go vet-go verify-source-map end-to-end-tests js-api-tests test-wasm
+	make -j7 test-go vet-go verify-source-map end-to-end-tests js-api-tests plugin-tests ts-type-tests test-wasm
 
 # This includes tests of some 3rd-party libraries, which can be very slow
 test-extra: test-all test-preact-splitting test-sucrase bench-rome-esbuild test-esprima test-rollup
@@ -43,6 +43,12 @@
 js-api-tests: cmd/esbuild/version.go | scripts/node_modules
 	cd npm/esbuild && npm version "$(ESBUILD_VERSION)" --allow-same-version
 	node scripts/js-api-tests.js
+
+plugin-tests: cmd/esbuild/version.go | scripts/node_modules
+	node scripts/plugin-tests.js
+
+ts-type-tests: | scripts/node_modules
+	node scripts/ts-type-tests.js
 
 cmd/esbuild/version.go: version.txt
 	node -e 'console.log(`package main\n\nconst esbuildVersion = "$(ESBUILD_VERSION)"`)' > cmd/esbuild/version.go
@@ -322,6 +328,3 @@
 
 demo/preact-splitting:
 	mkdir -p demo/preact-splitting/src
-	cd demo/preact-splitting && echo '{}' > package.json && npm i preact@10.4.6 preact-render-to-string@5.1.10
-	cd demo/preact-splitting && for h in $(PREACT_HOOKS); do echo "$(PREACT_SPLITTING)" | sed s/USE/$$h/ > src/$$h.js; done
-

=== debian/changelog ===
golang-github-evanw-esbuild (0.8.2-1) unstable; urgency=medium

  * New upstream version 0.8.2
  * Update esbuild(1) man page to 0.8.2

 -- Anthony Fok <foka@debian.org>  Tue, 03 Nov 2020 21:30:44 -0700

golang-github-evanw-esbuild (0.7.19-2) unstable; urgency=medium

  * Source-only upload for migration to testing

 -- Anthony Fok <foka@debian.org>  Wed, 28 Oct 2020 17:16:12 -0600

## golang-github-evanw-esbuild 0.8.3

=== debian/changelog ===
golang-github-evanw-esbuild (0.8.3-1) unstable; urgency=medium

  * New upstream version 0.8.3
  * Update esbuild(1) man page to 0.8.3

 -- Anthony Fok <foka@debian.org>  Thu, 05 Nov 2020 05:41:11 -0700

## golang-github-evanw-esbuild 0.8.6

=== Makefile ===
--- 
+++ 
@@ -115,7 +115,7 @@
 	test -n "$(OTP)" && echo publish --otp="$(OTP)"
 
 publish-all: cmd/esbuild/version.go test-all test-extra
-	@test master = "`git branch --show-current`" || (echo "Refusing to publish from non-master branch `git branch --show-current`" && false)
+	@test master = "`git rev-parse --abbrev-ref HEAD`" || (echo "Refusing to publish from non-master branch `git rev-parse --abbrev-ref HEAD`" && false)
 	@echo "Checking for unpushed commits..." && git fetch
 	@test "" = "`git cherry`" || (echo "Refusing to publish with unpushed commits" && false)
 	rm -fr npm && git checkout npm

=== debian/changelog ===
golang-github-evanw-esbuild (0.8.6-1) unstable; urgency=medium

  * New upstream version 0.8.6
  * debian/control: Change Section from devel to golang

 -- Anthony Fok <foka@debian.org>  Mon, 16 Nov 2020 04:30:57 -0700

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: golang-github-evanw-esbuild
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Anthony Fok <foka@debian.org>
-Section: devel
+Section: golang
 Testsuite: autopkgtest-pkg-go
 Priority: optional
 Build-Depends: debhelper-compat (= 13),

## golang-github-evanw-esbuild 0.8.15

=== Makefile ===
--- 
+++ 
@@ -1,13 +1,11 @@
 ESBUILD_VERSION = $(shell cat version.txt)
 
-esbuild: cmd/esbuild/*.go pkg/*/*.go internal/*/*.go go.mod
+esbuild: cmd/esbuild/version.go cmd/esbuild/*.go pkg/*/*.go internal/*/*.go go.mod
 	go build "-ldflags=-s -w" ./cmd/esbuild
 
-npm/esbuild-wasm/esbuild.wasm: cmd/esbuild/*.go pkg/*/*.go internal/*/*.go
+npm/esbuild-wasm/esbuild.wasm: cmd/esbuild/version.go cmd/esbuild/*.go pkg/*/*.go internal/*/*.go
+	cp "$(shell go env GOROOT)/misc/wasm/wasm_exec.js" npm/esbuild-wasm/wasm_exec.js
 	GOOS=js GOARCH=wasm go build -o npm/esbuild-wasm/esbuild.wasm ./cmd/esbuild
-
-npm/esbuild-wasm/wasm_exec.js:
-	cp "$(shell go env GOROOT)/misc/wasm/wasm_exec.js" npm/esbuild-wasm/wasm_exec.js
 
 # These tests are for development
 test:
@@ -18,7 +16,10 @@
 	make -j7 test-go vet-go verify-source-map end-to-end-tests js-api-tests plugin-tests ts-type-tests test-wasm
 
 # This includes tests of some 3rd-party libraries, which can be very slow
-test-extra: test-all test-preact-splitting test-sucrase bench-rome-esbuild test-esprima test-rollup
+test-prepublish: check-go-version test-all test-preact-splitting test-sucrase bench-rome-esbuild test-esprima test-rollup
+
+check-go-version:
+	@go version | grep 'go1\.15\.5' || (echo 'Please install Go version 1.15.5' && false)
 
 test-go:
 	go test ./internal/...
@@ -29,8 +30,9 @@
 fmt-go:
 	go fmt ./cmd/... ./internal/... ./pkg/...
 
-test-wasm:
+test-wasm: platform-wasm
 	PATH="$(shell go env GOROOT)/misc/wasm:$$PATH" GOOS=js GOARCH=wasm go test ./internal/...
+	npm/esbuild-wasm/bin/esbuild --version
 
 verify-source-map: cmd/esbuild/version.go | scripts/node_modules
 	cd npm/esbuild && npm version "$(ESBUILD_VERSION)" --allow-same-version
@@ -54,7 +56,7 @@
 	node -e 'console.log(`package main\n\nconst esbuildVersion = "$(ESBUILD_VERSION)"`)' > cmd/esbuild/version.go
 
 platform-all: cmd/esbuild/version.go test-all
-	make -j11 \
+	make -j8 \
 		platform-windows \
 		platform-windows-32 \
 		platform-darwin \
@@ -63,6 +65,7 @@
 		platform-linux \
 		platform-linux-32 \
 		platform-linux-arm64 \
+		platform-linux-mips64le \
 		platform-linux-ppc64le \
 		platform-wasm \
 		platform-neutral
@@ -99,10 +102,13 @@
 platform-linux-arm64:
 	make GOOS=linux GOARCH=arm64 NPMDIR=npm/esbuild-linux-arm64 platform-unixlike
 
+platform-linux-mips64le:
+	make GOOS=linux GOARCH=mips64le NPMDIR=npm/esbuild-linux-mips64le platform-unixlike
+
 platform-linux-ppc64le:
 	make GOOS=linux GOARCH=ppc64le NPMDIR=npm/esbuild-linux-ppc64le platform-unixlike
 
-platform-wasm: esbuild npm/esbuild-wasm/esbuild.wasm | scripts/node_modules npm/esbuild-wasm/wasm_exec.js
+platform-wasm: esbuild npm/esbuild-wasm/esbuild.wasm | scripts/node_modules
 	cd npm/esbuild-wasm && npm version "$(ESBUILD_VERSION)" --allow-same-version
 	mkdir -p npm/esbuild-wasm/lib
 	node scripts/esbuild.js ./esbuild --wasm
@@ -114,7 +120,7 @@
 test-otp:
 	test -n "$(OTP)" && echo publish --otp="$(OTP)"
 
-publish-all: cmd/esbuild/version.go test-all test-extra
+publish-all: cmd/esbuild/version.go test-prepublish
 	@test master = "`git rev-parse --abbrev-ref HEAD`" || (echo "Refusing to publish from non-master branch `git rev-parse --abbrev-ref HEAD`" && false)
 	@echo "Checking for unpushed commits..." && git fetch
 	@test "" = "`git cherry`" || (echo "Refusing to publish with unpushed commits" && false)
@@ -131,9 +137,13 @@
 		publish-linux \
 		publish-linux-32 \
 		publish-linux-arm64 \
-		publish-linux-ppc64le \
+		publish-linux-mips64le \
+		publish-linux-ppc64le
+	# Do these last to avoid race conditions
+	@echo Enter one-time password:
+	@read OTP && OTP="$$OTP" make -j2 \
+		publish-neutral \
 		publish-wasm
-	make publish-neutral # Do this after to avoid race conditions
 	git commit -am "publish $(ESBUILD_VERSION) to npm"
 	git tag "v$(ESBUILD_VERSION)"
 	git push origin master "v$(ESBUILD_VERSION)"
@@ -162,6 +172,9 @@
 publish-linux-arm64: platform-linux-arm64
 	test -n "$(OTP)" && cd npm/esbuild-linux-arm64 && npm publish --otp="$(OTP)"
 
+publish-linux-mips64le: platform-linux-mips64le
+	test -n "$(OTP)" && cd npm/esbuild-linux-mips64le && npm publish --otp="$(OTP)"
+
 publish-linux-ppc64le: platform-linux-ppc64le
 	test -n "$(OTP)" && cd npm/esbuild-linux-ppc64le && npm publish --otp="$(OTP)"
 
@@ -169,7 +182,7 @@
 	test -n "$(OTP)" && cd npm/esbuild-wasm && npm publish --otp="$(OTP)"
 
 publish-neutral: platform-neutral
-	cd npm/esbuild && npm publish
+	test -n "$(OTP)" && cd npm/esbuild && npm publish --otp="$(OTP)"
 
 clean:
 	rm -f esbuild
@@ -181,6 +194,7 @@
 	rm -rf npm/esbuild-linux-32/bin
 	rm -rf npm/esbuild-linux-64/bin
 	rm -rf npm/esbuild-linux-arm64/bin
+	rm -rf npm/esbuild-linux-mips64le/bin
 	rm -rf npm/esbuild-linux-ppc64le/bin
 	rm -f npm/esbuild-wasm/esbuild.wasm npm/esbuild-wasm/wasm_exec.js
 	rm -rf npm/esbuild/lib
@@ -310,21 +324,3 @@
 
 PREACT_SPLITTING += import { h } from 'preact';
 PREACT_SPLITTING += import { USE as use } from 'preact/hooks';
-PREACT_SPLITTING += import { renderToString } from 'preact-render-to-string';
-PREACT_SPLITTING += let Component = () => (use(() => {}), h('div'));
-PREACT_SPLITTING += if (renderToString(h(Component)) !== '<div></div>') throw 'fail';
-
-PREACT_HOOKS += useCallback
-PREACT_HOOKS += useContext
-PREACT_HOOKS += useDebugValue
-PREACT_HOOKS += useEffect
-PREACT_HOOKS += useErrorBoundary
-PREACT_HOOKS += useImperativeHandle
-PREACT_HOOKS += useLayoutEffect
-PREACT_HOOKS += useMemo
-PREACT_HOOKS += useReducer
-PREACT_HOOKS += useRef
-PREACT_HOOKS += useState
-
-demo/preact-splitting:
-	mkdir -p demo/preact-splitting/src

=== debian/changelog ===
golang-github-evanw-esbuild (0.8.15-1) unstable; urgency=medium

  * New upstream version 0.8.15
  * Remove unnecessary dependency kylelemons/godebug as per upstream
  * Update esbuild(1) man page to 0.8.15
  * Bump Standards-Version to 4.5.1 (no change)

 -- Anthony Fok <foka@debian.org>  Wed, 02 Dec 2020 00:39:26 -0700

=== debian/control ===
--- 
+++ 
@@ -7,9 +7,8 @@
 Build-Depends: debhelper-compat (= 13),
                dh-golang,
                golang-any,
-               golang-github-kylelemons-godebug-dev (>= 1.1.0),
                golang-golang-x-sys-dev (>= 0.0~git20200501.bc7a7d4)
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-evanw-esbuild
 Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-evanw-esbuild.git
 Homepage: https://github.com/evanw/esbuild
@@ -18,8 +17,7 @@
 
 Package: golang-github-evanw-esbuild-dev
 Architecture: all
-Depends: golang-github-kylelemons-godebug-dev (>= 1.1.0),
-         golang-golang-x-sys-dev (>= 0.0~git20200501.bc7a7d4),
+Depends: golang-golang-x-sys-dev (>= 0.0~git20200501.bc7a7d4),
          ${misc:Depends}
 Description: extremely fast JavaScript bundler and minifier (library)
  esbuild is a JavaScript bundler and minifier.  It packages up

## golang-github-evanw-esbuild 0.8.28

=== Makefile ===
--- 
+++ 
@@ -7,13 +7,15 @@
 	cp "$(shell go env GOROOT)/misc/wasm/wasm_exec.js" npm/esbuild-wasm/wasm_exec.js
 	GOOS=js GOARCH=wasm go build -o npm/esbuild-wasm/esbuild.wasm ./cmd/esbuild
 
+test:
+	make -j6 test-common
+
 # These tests are for development
-test:
-	make -j6 test-go vet-go verify-source-map end-to-end-tests js-api-tests plugin-tests ts-type-tests
-
-# These tests are for release ("test-wasm" is not included in "test" because it's pretty slow)
+test-common: test-go vet-go verify-source-map end-to-end-tests js-api-tests plugin-tests register-test
+
+# These tests are for release (the extra tests are not included in "test" because they are pretty slow)
 test-all:
-	make -j7 test-go vet-go verify-source-map end-to-end-tests js-api-tests plugin-tests ts-type-tests test-wasm
+	make -j6 test-common ts-type-tests test-wasm-node test-wasm-browser
 
 # This includes tests of some 3rd-party libraries, which can be very slow
 test-prepublish: check-go-version test-all test-preact-splitting test-sucrase bench-rome-esbuild test-esprima test-rollup
@@ -30,10 +32,17 @@
 fmt-go:
 	go fmt ./cmd/... ./internal/... ./pkg/...
 
-test-wasm: platform-wasm
+test-wasm-node: platform-wasm
 	PATH="$(shell go env GOROOT)/misc/wasm:$$PATH" GOOS=js GOARCH=wasm go test ./internal/...
 	npm/esbuild-wasm/bin/esbuild --version
 
+test-wasm-browser: platform-wasm | scripts/browser/node_modules
+	cd scripts/browser && node browser-tests.js
+
+register-test: cmd/esbuild/version.go | scripts/node_modules
+	cd npm/esbuild && npm version "$(ESBUILD_VERSION)" --allow-same-version
+	node scripts/register-test.js
+
 verify-source-map: cmd/esbuild/version.go | scripts/node_modules
 	cd npm/esbuild && npm version "$(ESBUILD_VERSION)" --allow-same-version
 	node scripts/verify-source-map.js
@@ -51,6 +60,9 @@
 
 ts-type-tests: | scripts/node_modules
 	node scripts/ts-type-tests.js
+
+lib-typecheck: | lib/node_modules
+	cd lib && node_modules/.bin/tsc -noEmit -p .
 
 cmd/esbuild/version.go: version.txt
 	node -e 'console.log(`package main\n\nconst esbuildVersion = "$(ESBUILD_VERSION)"`)' > cmd/esbuild/version.go
@@ -64,6 +76,7 @@
 		platform-freebsd-arm64 \
 		platform-linux \
 		platform-linux-32 \
+		platform-linux-arm \
 		platform-linux-arm64 \
 		platform-linux-mips64le \
 		platform-linux-ppc64le \
@@ -99,6 +112,9 @@
 platform-linux-32:
 	make GOOS=linux GOARCH=386 NPMDIR=npm/esbuild-linux-32 platform-unixlike
 
+platform-linux-arm:
+	make GOOS=linux GOARCH=arm NPMDIR=npm/esbuild-linux-arm platform-unixlike
+
 platform-linux-arm64:
 	make GOOS=linux GOARCH=arm64 NPMDIR=npm/esbuild-linux-arm64 platform-unixlike
 
@@ -113,7 +129,7 @@
 	mkdir -p npm/esbuild-wasm/lib
 	node scripts/esbuild.js ./esbuild --wasm
 
-platform-neutral: esbuild | scripts/node_modules
+platform-neutral: esbuild lib-typecheck | scripts/node_modules
 	cd npm/esbuild && npm version "$(ESBUILD_VERSION)" --allow-same-version
 	node scripts/esbuild.js ./esbuild
 
@@ -126,16 +142,19 @@
 	@test "" = "`git cherry`" || (echo "Refusing to publish with unpushed commits" && false)
 	rm -fr npm && git checkout npm
 	@echo Enter one-time password:
-	@read OTP && OTP="$$OTP" make -j5 \
+	@read OTP && OTP="$$OTP" make -j4 \
 		publish-windows \
 		publish-windows-32 \
-		publish-darwin \
 		publish-freebsd \
 		publish-freebsd-arm64
 	@echo Enter one-time password:
-	@read OTP && OTP="$$OTP" make -j5 \
+	@read OTP && OTP="$$OTP" make -j4 \
+		publish-darwin \
 		publish-linux \
-		publish-linux-32 \
+		publish-linux-32
+	@echo Enter one-time password:
+	@read OTP && OTP="$$OTP" make -j4 \
+		publish-linux-arm \
 		publish-linux-arm64 \
 		publish-linux-mips64le \
 		publish-linux-ppc64le
@@ -169,6 +188,9 @@
 publish-linux-32: platform-linux-32
 	test -n "$(OTP)" && cd npm/esbuild-linux-32 && npm publish --otp="$(OTP)"
 
+publish-linux-arm: platform-linux-arm
+	test -n "$(OTP)" && cd npm/esbuild-linux-arm && npm publish --otp="$(OTP)"
+
 publish-linux-arm64: platform-linux-arm64
 	test -n "$(OTP)" && cd npm/esbuild-linux-arm64 && npm publish --otp="$(OTP)"
 
@@ -193,6 +215,7 @@
 	rm -rf npm/esbuild-freebsd-amd64/bin
 	rm -rf npm/esbuild-linux-32/bin
 	rm -rf npm/esbuild-linux-64/bin
+	rm -rf npm/esbuild-linux-arm/bin
 	rm -rf npm/esbuild-linux-arm64/bin
 	rm -rf npm/esbuild-linux-mips64le/bin
 	rm -rf npm/esbuild-linux-ppc64le/bin
@@ -227,24 +250,25 @@
 require/parcel/node_modules:
 	mkdir -p require/parcel
 	echo '{}' > require/parcel/package.json
-	cd require/parcel && npm install parcel@1.12.4
+	cd require/parcel && npm install parcel@1.12.4 typescript@4.1.2
 
 	# Fix a bug where parcel doesn't know about one specific node builtin module
 	mkdir -p require/parcel/node_modules/inspector
 	touch require/parcel/node_modules/inspector/index.js
 
-require/fusebox/node_modules:
-	mkdir -p require/fusebox
-	echo '{}' > require/fusebox/package.json
-	cd require/fusebox && npm install fuse-box@4.0.0-next.444
-
 require/parcel2/node_modules:
 	mkdir -p require/parcel2
 	echo '{}' > require/parcel2/package.json
-	cd require/parcel2 && npm install parcel@2.0.0-nightly.420 @parcel/transformer-typescript-tsc@2.0.0-beta.1 typescript@3.9.5
+	cd require/parcel2 && npm install parcel@2.0.0-nightly.475 @parcel/transformer-typescript-tsc@2.0.0-nightly.477 typescript@4.1.2
+
+lib/node_modules:
+	cd lib && npm ci
 
 scripts/node_modules:
 	cd scripts && npm ci
+
+scripts/browser/node_modules:
+	cd scripts/browser && npm ci
 
 ################################################################################
 # This downloads the kangax compat-table and generates browser support mappings
@@ -311,16 +335,3 @@
 	cp -RP github/rollup/ demo/rollup
 	cd demo/rollup && npm ci
 
-	# Patch over Rollup's custom "package.json" alias using "tsconfig.json"
-	cat demo/rollup/tsconfig.json | sed 's/$(TEST_ROLLUP_FIND)/$(TEST_ROLLUP_REPLACE)/' > demo/rollup/tsconfig2.json
-	mv demo/rollup/tsconfig2.json demo/rollup/tsconfig.json
-
-test-rollup: esbuild | demo/rollup
-	cd demo/rollup && ../../esbuild $(TEST_ROLLUP_FLAGS) && npm run test:only
-	cd demo/rollup && ../../esbuild $(TEST_ROLLUP_FLAGS) --minify && npm run test:only
-
-################################################################################
-# This builds Sucrase using esbuild and then uses it to run Sucrase's test suite
-
-PREACT_SPLITTING += import { h } from 'preact';
-PREACT_SPLITTING += import { USE as use } from 'preact/hooks';

=== debian/changelog ===
golang-github-evanw-esbuild (0.8.28-1) unstable; urgency=medium

  * New upstream version 0.8.28
  * Bump build-dependency on golang-any to (>= 2:1.13~)
    as per go.mod
  * Update esbuild(1) man page to 0.8.28

 -- Anthony Fok <foka@debian.org>  Thu, 31 Dec 2020 17:39:50 -0700

## golang-github-evanw-esbuild 0.8.39

=== Makefile ===
--- 
+++ 
@@ -3,15 +3,11 @@
 esbuild: cmd/esbuild/version.go cmd/esbuild/*.go pkg/*/*.go internal/*/*.go go.mod
 	go build "-ldflags=-s -w" ./cmd/esbuild
 
-npm/esbuild-wasm/esbuild.wasm: cmd/esbuild/version.go cmd/esbuild/*.go pkg/*/*.go internal/*/*.go
-	cp "$(shell go env GOROOT)/misc/wasm/wasm_exec.js" npm/esbuild-wasm/wasm_exec.js
-	GOOS=js GOARCH=wasm go build -o npm/esbuild-wasm/esbuild.wasm ./cmd/esbuild
-
 test:
 	make -j6 test-common
 
 # These tests are for development
-test-common: test-go vet-go verify-source-map end-to-end-tests js-api-tests plugin-tests register-test
+test-common: test-go vet-go no-filepath verify-source-map end-to-end-tests js-api-tests plugin-tests register-test
 
 # These tests are for release (the extra tests are not included in "test" because they are pretty slow)
 test-all:
@@ -21,7 +17,7 @@
 test-prepublish: check-go-version test-all test-preact-splitting test-sucrase bench-rome-esbuild test-esprima test-rollup
 
 check-go-version:
-	@go version | grep 'go1\.15\.5' || (echo 'Please install Go version 1.15.5' && false)
+	@go version | grep 'go1\.15\.7' || (echo 'Please install Go version 1.15.7' && false)
 
 test-go:
 	go test ./internal/...
@@ -32,9 +28,13 @@
 fmt-go:
 	go fmt ./cmd/... ./internal/... ./pkg/...
 
-test-wasm-node: platform-wasm
+no-filepath:
+	@! grep --color --include '*.go' -r '"path/filepath"' cmd internal pkg || ( \
+		echo 'error: Use of "path/filepath" is disallowed. See http://golang.org/issue/43768.' && false)
+
+test-wasm-node: esbuild
 	PATH="$(shell go env GOROOT)/misc/wasm:$$PATH" GOOS=js GOARCH=wasm go test ./internal/...
-	npm/esbuild-wasm/bin/esbuild --version
+	node scripts/wasm-tests.js
 
 test-wasm-browser: platform-wasm | scripts/browser/node_modules
 	cd scripts/browser && node browser-tests.js
@@ -66,6 +66,26 @@
 
 cmd/esbuild/version.go: version.txt
 	node -e 'console.log(`package main\n\nconst esbuildVersion = "$(ESBUILD_VERSION)"`)' > cmd/esbuild/version.go
+
+wasm-napi-exit0-darwin:
+	node -e 'console.log(`#include <unistd.h>\nvoid* napi_register_module_v1(void* a, void* b) { _exit(0); }`)' \
+		| clang -x c -dynamiclib -mmacosx-version-min=10.5 -o npm/esbuild-wasm/exit0/darwin-x64-LE.node -
+	ls -l npm/esbuild-wasm/exit0/darwin-x64-LE.node
+
+wasm-napi-exit0-linux:
+	node -e 'console.log(`#include <unistd.h>\nvoid* napi_register_module_v1(void* a, void* b) { _exit(0); }`)' \
+		| gcc -x c -shared -o npm/esbuild-wasm/exit0/linux-x64-LE.node -
+	strip npm/esbuild-wasm/exit0/linux-x64-LE.node
+	ls -l npm/esbuild-wasm/exit0/linux-x64-LE.node
+
+wasm-napi-exit0-windows:
+	# This isn't meant to be run directly but is a rough overview of the instructions
+	echo '__declspec(dllexport) void* napi_register_module_v1(void* a, void* b) { ExitProcess(0); }' > main.c
+	echo 'setlocal' > main.bat
+	echo 'call "C:\Program Files (x86)\Microsoft Visual Studio\2019\Community\VC\Auxiliary\Build\vcvarsall.bat" x64' >> main.bat
+	echo 'cl.exe /LD main.c /link /DLL /NODEFAULTLIB /NOENTRY kernel32.lib /OUT:npm/esbuild-wasm/exit0/win32-x64-LE.node' >> main.bat
+	main.bat
+	rm -f main.*
 
 platform-all: cmd/esbuild/version.go test-all
 	make -j8 \
@@ -124,9 +144,8 @@
 platform-linux-ppc64le:
 	make GOOS=linux GOARCH=ppc64le NPMDIR=npm/esbuild-linux-ppc64le platform-unixlike
 
-platform-wasm: esbuild npm/esbuild-wasm/esbuild.wasm | scripts/node_modules
+platform-wasm: esbuild | scripts/node_modules
 	cd npm/esbuild-wasm && npm version "$(ESBUILD_VERSION)" --allow-same-version
-	mkdir -p npm/esbuild-wasm/lib
 	node scripts/esbuild.js ./esbuild --wasm
 
 platform-neutral: esbuild lib-typecheck | scripts/node_modules
@@ -222,6 +241,9 @@
 	rm -f npm/esbuild-wasm/esbuild.wasm npm/esbuild-wasm/wasm_exec.js
 	rm -rf npm/esbuild/lib
 	rm -rf npm/esbuild-wasm/lib
+	rm -rf require/*/bench/
+	rm -rf require/*/demo/
+	rm -rf require/*/node_modules/
 	go clean -testcache ./internal/...
 
 # This also cleans directories containing cached code from other projects
@@ -233,33 +255,23 @@
 # because we want to install the same package name at multiple versions
 
 require/webpack/node_modules:
-	mkdir -p require/webpack
-	echo '{}' > require/webpack/package.json
-	cd require/webpack && npm install webpack@4.44.2 webpack-cli@3.3.12 ts-loader@8.0.4 typescript@4.0.3
+	cd require/webpack && npm ci
 
 require/webpack5/node_modules:
-	mkdir -p require/webpack5
-	echo '{}' > require/webpack5/package.json
-	cd require/webpack5 && npm install webpack@5.0.0-rc.4 webpack-cli@4.0.0-rc.1 ts-loader@8.0.4 typescript@4.0.3
+	cd require/webpack5 && npm ci
 
 require/rollup/node_modules:
-	mkdir -p require/rollup
-	echo '{}' > require/rollup/package.json
-	cd require/rollup && npm install rollup@2.29.0 rollup-plugin-terser@7.0.2
+	cd require/rollup && npm ci
 
 require/parcel/node_modules:
-	mkdir -p require/parcel
-	echo '{}' > require/parcel/package.json
-	cd require/parcel && npm install parcel@1.12.4 typescript@4.1.2
+	cd require/parcel && npm ci
 
 	# Fix a bug where parcel doesn't know about one specific node builtin module
 	mkdir -p require/parcel/node_modules/inspector
 	touch require/parcel/node_modules/inspector/index.js
 
 require/parcel2/node_modules:
-	mkdir -p require/parcel2
-	echo '{}' > require/parcel2/package.json
-	cd require/parcel2 && npm install parcel@2.0.0-nightly.475 @parcel/transformer-typescript-tsc@2.0.0-nightly.477 typescript@4.1.2
+	cd require/parcel2 && npm ci
 
 lib/node_modules:
 	cd lib && npm ci
@@ -322,16 +334,3 @@
 TEST_ROLLUP_FLAGS += --bundle
 TEST_ROLLUP_FLAGS += --external:fsevents
 TEST_ROLLUP_FLAGS += --outfile=dist/rollup.js
-TEST_ROLLUP_FLAGS += --platform=node
-TEST_ROLLUP_FLAGS += --target=es6
-TEST_ROLLUP_FLAGS += src/node-entry.ts
-
-github/rollup:
-	mkdir -p github
-	git clone --depth 1 --branch v2.15.0 https://github.com/rollup/rollup.git github/rollup
-
-demo/rollup: | github/rollup
-	mkdir -p demo
-	cp -RP github/rollup/ demo/rollup
-	cd demo/rollup && npm ci
-

=== debian/changelog ===
golang-github-evanw-esbuild (0.8.39-1) unstable; urgency=medium

  * New upstream version 0.8.39
  * Update esbuild(1) man page to 0.8.39

 -- Anthony Fok <foka@debian.org>  Mon, 01 Feb 2021 06:16:09 -0700

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-golang,
-               golang-any,
+               golang-any (>= 2:1.13~),
                golang-golang-x-sys-dev (>= 0.0~git20200501.bc7a7d4)
 Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-evanw-esbuild

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOLANG_INSTALL_EXTRA := internal/bundler/snapshots

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%golang-github-evanw-esbuild-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/\$1~\$2\$3/" \
  https://github.com/evanw/esbuild/tags .*/v?(\d\S*)\.tar\.gz debian
